<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">{{ $t('SGROUP.TITLE') }}</h2>
    <div style="display:inline; float: right; margin-top:-50px;">   
      <el-button size="small" @click="onClick('BACK')" :class="$attachReactablePostfix('el-btn')">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
    </div>   
		<el-card class="border-card">
      <div style="display:inline; float: right;">   
      <el-button size="small"  @click="centerDialogVisible = true" :class="$attachReactablePostfix('el-btn')">{{ $t('SGROUP.CREATE') }}</el-button>
        <el-dialog   
          :title="$t('SGROUP.NEW_ROOM')"
          :visible.sync="centerDialogVisible"
          width="30%"> 
          <div>
            <el-form @submit.native.prevent :model="input" ref="elForm" label-width="100px" style="max-width: 350px;">
              <el-form-item :label="$t('SGROUP.NAME')">
                <el-input v-model="input.name"  class="room-title"></el-input>
              </el-form-item>
              <el-form-item :label="$t('SGROUP.TYPE')">
                <el-radio-group v-model.number="input.type">
                  <el-radio :label="0">{{ $t('SGROUP.REG') }}</el-radio>
                  <el-radio :label="1">{{ $t('SGROUP.TEMP') }}</el-radio>
                </el-radio-group>
              </el-form-item>
              <el-form-item :label="$t('SGROUP.MAX')">
                <el-input v-model="input.num" type="number" min=1 max=100></el-input>
              </el-form-item>
              <el-form-item :label="$t('SGROUP.PASSWORD')">
                <el-input v-model="input.password"></el-input>
              </el-form-item>
            </el-form>
            <el-button type="small" align = "right" style="margin: 0px 10px 0px 0px" @click="onClick('CREATE',centerDialogVisible=false)">{{ $t('SGROUP.CREATE') }}</el-button>
          </div>
        </el-dialog> 
      </div>             
      <el-table
        class="elTable-label"
        :data="inputlist"
        :default-sort = "{prop: 'room_id', order: 'ascending'}">
        <el-table-column
          prop="room_id"
          :label="$t('SGROUP.INDEX')"
          width="120"
          align="center"
        >
          <template slot-scope="scope">
            {{ scope.$index + 1 }}
          </template>
        </el-table-column>
        <el-table-column
          prop="name"
          :label="$t('SGROUP.NAME')"
          width="300"
          align="center"
        >        

        </el-table-column>
        <el-table-column
          prop="creater"
          :label="$t('SGROUP.CREATER')"
          width="200"
          align="center"
        >        

        </el-table-column>
        <el-table-column
          prop="max_occupancy"
          :label="$t('SGROUP.NUM')"
          width="120"
          align="center"
        >        
          <template slot-scope="scope">{{ scope.row.current+"/"+scope.row.max_occupancy}}</template>
        </el-table-column>

        <el-table-column
           label="-"
           width="120"
           align="center"
        >
          <template slot-scope="scope">
            <el-button  @click="onClickEnter(scope.row.room_id)">{{ $t('SGROUP.ENTER') }}</el-button>
          </template>        
        </el-table-column>
     
        <el-table-column
           label="-"
           width="120"
           align="center"
        >
        <!--room id/edit으로 이동 -->
          <template slot-scope="scope">
            <el-button  @click="onClickEdit(scope.row.room_id)">{{ $t('SGROUP.EDIT') }}</el-button>
          </template>
        </el-table-column>
       
        <el-table-column
           label="-"
           width="120"
           align="center"
        >
          <template slot-scope="scope">
           <el-button type="danger" @click="onClickDelete(scope.row)" >{{ $t('SGROUP.DEL') }}</el-button>
          </template>
        </el-table-column>                

      </el-table>   
		</el-card>    
  </div>
</template>


<script>
import Sortable from 'sortablejs';
import deepCopy from 'deep-copy';
import { mapState, mapActions, mapGetters } from 'vuex';
import LectureList from '../partials/LectureList';
import utils from '../../utils';
import lectureService from '../../services/lectureService';
import authService from '../../services/authService';
import userService from '../../services/userService';
import classService from '../../services/classService';

export default {
  name: 'SGroup',
  async created() {
    const vm = this;

    //방 정보 받아오고, 생성자 추가
    const roomInfo = await lectureService.newgetSmallMeetingRoomList({
      classId : vm.classId,
    });
    
    roomInfo.data.forEach(async (x) => {
      
      // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
      if (vm.lectureId != x.lecture_id){
        return;
      }

      const res = await userService.getUserNameByUserId({
        userId : x.user_id,
      });
      const res2 = await lectureService.getCurrentStudentCount({
        roomId : x.room_id,
      })
      x.creater = res.data.userInfo.name;
      x.current = res2.data.count
      

      vm.inputlist.push(x);
    });
    //전체 학생 카운트
    const listOfStudents = await lectureService.getWholeStudents({
      id: vm.$route.params.lectureId,
    });    
    vm.listOfStudents = listOfStudents.data;
    vm.listOfStudents.forEach((x) => {
      vm.count++;
    });
    //로그인 한 사람 id, type, name 구하기
    vm.myId = await utils.getUserIdFromJwt();
    const myInfo = await userService.getUserNameByUserId({
      userId : vm.myId,
    })
    vm.mytype = myInfo.data.userInfo.type;
    vm.myname = myInfo.data.userInfo.name;
  },
  components: {
    LectureList,
  },
  data() {
    const initialInput = {
      name: '',
      type: 0,
      roomCreateDate: new Date(),
      num: '',
      password: '',
    };    
    return {
      initialInput,
      input: Object.assign({}, initialInput), // 복사해서 넣음      
      centerDialogVisible: false,
      inputlist: [],
      listOfStudents: undefined,      
      count: 0,
      lectureId: this.$router.currentRoute.params.lectureId,
      //roomId: 0,
      myId: 0,
      mytype: 0,
      myname: '',
      authStudents: [],
    };
  },
  // async mounted() {  - 일정 시간 뒤 삭제는 여기 구현하는것 보다 다른 좋은 위치가 있을 것 같아서 주석 처리해둡니다.
  //   const vm = this;
  //   //임시방 시간 지나면 삭제
  //   vm.deleteTemp();
  // },
  computed: {
    ...mapState('NNclass', [
      'teachingClassList',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('NNclass', [
      'getClass',
      'getMyClassLists',
      'deleteLectureFromClass',
    ]),
    // //임시방 6시간 지나면 삭제 - 일정 시간 뒤 삭제는 여기 구현하는것 보다 다른 좋은 위치가 있을 것 같아서 주석 처리해둡니다.
    // async deleteTemp() {
    //   const vm = this;
    //   setInterval(() => {
    //     const currentTime = new Date();
    //     vm.inputlist.forEach(async(element) => {
    //       var eledate = new Date(element.createdAt);
    //       if(((currentTime - eledate)>21600000) && (element.type === 1)){
    //         const roomInfo = await lectureService.newgetSmallMeetingRoomList({
    //           classId : vm.classId,
    //         })            
    //         await lectureService.deleteSmallMeetingRoom({ roomId: element.room_id });
    //         vm.inputlist = [],
    //         roomInfo.data.forEach(async (x) => {
    //           const res = await userService.getUserNameByUserId({
    //             userId : x.user_id,
    //           });
    //         const res2 = await lectureService.getCurrentStudentCount({
    //           roomId : x.room_id,
    //         })
    //         x.creater = res.data.userInfo.name;
    //         x.current = res2.data.count
    //         vm.inputlist.push(x);
    //         });            
    //       }
    //     });
    //   }, 1000);
    // },    
    async onClick(type) {
      const vm = this;
      const userId = utils.getUserIdFromJwt();
      
      switch (type) {
        case 'BACK': {
          location.href = "javascript:history.back();";
          break;          
        }        
        case 'CREATE': {
          const max_num = vm.input.num;
          //강사일 때 무제한 생성 가능
          if(vm.mytype === 1){
            if (max_num > vm.count+1 || max_num < 1 || max_num.length === 0) {
                vm.$notify({
                  title: vm.$t('NOTIFY.TITLE'),
                  message: vm.$t('NOTIFY.INPUT_RIGHT_NUM'),
                  //한 줄 더 하고싶...
                  type: 'error',
                });
                this.$refs.elForm.resetFields();
                return;
            }   
            //inputlist에 추가
            // const tmp = {
            //   name: vm.input.name,
            //   type: vm.input.type,
            //   roomCreateDate: vm.input.roomCreateDate,
            //   creater: vm.myname,
            //   max_occupancy: vm.input.num,
            //   current: 0,
            // }
            
            const newroom = await lectureService.postSmallMeetingRoom({
                classId: vm.classId,
                type: vm.input.type,
                name: vm.input.name,
                max_occupancy: vm.input.num,
                password: vm.input.password,
                lectureId: vm.lectureId,
            });

            const roomInfo = await lectureService.newgetSmallMeetingRoomList({
              classId : vm.classId,
            })
            vm.inputlist = [],
            roomInfo.data.forEach(async (x) => {
              // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
              if (vm.lectureId != x.lecture_id){
                return;
              }

              const res = await userService.getUserNameByUserId({
                userId : x.user_id,
              });
              const res2 = await lectureService.getCurrentStudentCount({
                roomId : x.room_id,
              })
              x.creater = res.data.userInfo.name;
              x.current = res2.data.count              
              
              vm.inputlist.push(x);
            });
          }
          //학생일 때 방 한개밖에 못만들게
          else{
            if (max_num > vm.count+1 || max_num < 1 || max_num.length === 0) {
                vm.$notify({
                  title: vm.$t('NOTIFY.FAIL'),
                  message: vm.$t('NOTIFY.INPUT_RIGHT_NUM'),
                  //한 줄 더 하고싶...
                  type: 'error',
                });
                this.$refs.elForm.resetFields();
                return;
            }   
            //방 만든 것 있는지 확인
            var isRight = false;
            vm.inputlist.forEach(x => {
              if(x.user_id === vm.myId){
                isRight = true;
              }
            })
            if(isRight){
              vm.$notify({
                title: vm.$t('NOTIFY.FAIL'),
                message: vm.$t('NOTIFY.SGROUP_CREATE_FAIL'),
                //한 줄 더 하고싶...
                type: 'error',
              });
              this.$refs.elForm.resetFields();
              return;              
            }            
            // //inputlist에 추가
            // const tmp = {
            //   name: vm.input.name,
            //   type: vm.input.type,
            //   roomCreateDate: vm.input.roomCreateDate,
            //   creater: vm.myname,
            //   max_occupancy: vm.input.num,
            //   current: 0,
            // }
            const newroom = await lectureService.postSmallMeetingRoom({
                classId: vm.classId,
                type: vm.input.type,
                name: vm.input.name,
                max_occupancy: vm.input.num,
                password: vm.input.password,
                lectureId: vm.lectureId,
            });

            const roomInfo = await lectureService.newgetSmallMeetingRoomList({
              classId : vm.classId,
            })
            vm.inputlist = [],
            roomInfo.data.forEach(async (x) => {
              // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
              if (vm.lectureId != x.lecture_id){
                return;
              }
              const res = await userService.getUserNameByUserId({
                userId : x.user_id,
              });
              const res2 = await lectureService.getCurrentStudentCount({
                roomId : x.room_id,
              })
              x.creater = res.data.userInfo.name;
              x.current = res2.data.count              
              
              vm.inputlist.push(x);
            });        
          }
          break;
        };
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    async onClickEnter(value) {
      //value : room_id => 이용해서 방 정보 확인, 현재 원 체크해서 max이상이면 빠꾸
      //방 정보에서 권한 없을 경우도 빠꾸
      const vm = this;
      if(vm.mytype === 1){
        //강사일 때는 명수 체크만
        var isFull = false;
        vm.inputlist.forEach(x => {
          if(x.room_id === value){
            if(x.current >= x.max_occupancy){
              isFull = true;
            }
          }
        })        
        if(isFull){
          vm.$notify({
            title: vm.$t('NOTIFY.FAIL'),
            message: vm.$t('NOTIFY.SGROUP_FULL'),
            type: 'error',
            duration: 3000,
          });          
        }
        else{
          vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}`});
        }
      }
      else{
        //명 수 체크 필요
        try {
          //방 꽉찬지 확인
          var isFull = false;
          //접근하고자 하는 사람이 생성자와 같은 경우 그냥 입장
          var isCreate = false;
          vm.inputlist.forEach(x => {
            if(x.room_id === value){
              if(x.current >= x.max_occupancy){
                isFull = true;
              }
              if(x.user_id === vm.myId){
                isCreate = true;
              }
            }
          })       
          if(isFull){
            vm.$notify({
              title: vm.$t('NOTIFY.PERMIT_FAIL'),
              message: vm.$t('NOTIFY.SGROUP_FULL'),
              type: 'error',
              duration: 3000,
            });      
            return
          }  

          if(isCreate && !isFull){
            vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}`});            
          }
          //권한 체크
          var isAuth = false;
          var tmp = await lectureService.getPermittedUserList({
            roomId : value,
          })
          vm.authStudents = tmp.data
          
          if(vm.authStudents.length === 0 && !isFull){
            vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}`});
            return;
          }
          vm.authStudents.forEach(x => {
            if(vm.myId === x.user_id){
              isAuth = true;
            }
          })
          if(!isFull){ // 권한 잠금 버그로 인해  일시 해제
            vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}`});
            return;
          }
          // if(isAuth && !isFull){
          //   vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}`});
          //   return;
          // }
          // else{
          //   vm.$notify({
          //     title: vm.$t('NOTIFY.PERMIT_FAIL'),
          //     message: vm.$t('NOTIFY.PERMIT_ERROR'),
          //     type: 'error',
          //     duration: 3000,
          //   });            
          // }
        } catch (error) {          
          vm.$notify({
            title: vm.$t('NOTIFY.PERMIT_FAIL'),
            message: vm.$t('NOTIFY.PERMIT_ERROR'),
            type: 'error',
            duration: 3000,
          });
        }
      }
    },
    async onClickEdit(value) {
      //"`/a/SGRoup/${lectureId}/${classId}/${scope.row.room_id}/edit`">

      //방 정보에서 권한 없을 경우도 빠꾸
      const vm = this;
      if(vm.mytype === 1){
        //강사일 때 무조건 입장 가능
        
        vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}/edit`});
      }
      else{
        //creater과 같은지 확인
        try {
          var isRight = false;
          vm.inputlist.forEach(x => {
            if(x.room_id === value){
              if(x.user_id === vm.myId){
                isRight = true;
              }
            }
          })
          if(isRight){
            vm.$router.push({path: `/a/SGRoup/${vm.lectureId}/${vm.classId}/${value}/edit`});
          }
          else{
            vm.$notify({
              title: vm.$t('NOTIFY.SGROUP_EDIT_ERROR'),
              message: vm.$t('NOTIFY.PERMIT_EDIT_ERROR'),
              type: 'error',
              duration: 3000,
            });            
          }
        } catch (error) {          
          vm.$notify({
            title: vm.$t('NOTIFY.SGROUP_EDIT_ERROR'),
            message: vm.$t('NOTIFY.PERMIT_EDIT_ERROR'),
            type: 'error',
            duration: 3000,
          });         
        }
      }
    },    
    async onClickDelete(index) {
      const vm = this;
      const targetId = index.room_id;
      //강사는 그냥 방 지우기 가능
      if(vm.mytype === 1){
        vm.$confirm(vm.$t('CONFIRM.WANT_DELETE_ROOM'), vm.$t('CONFIRM.DELETE'), {
          confirmButtonText: vm.$t('NOTE.CONFIRM'),
          cancelButtonText: vm.$t('NOTIFY.CANCEL'),
          type: 'warning',
        })       
      .then(async () => {
        try {
          await lectureService.deleteSmallMeetingRoom({ roomId: targetId });
          const roomInfo = await lectureService.newgetSmallMeetingRoomList({
            classId : vm.classId,
          })
          vm.inputlist = [],
          roomInfo.data.forEach(async (x) => {
            // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
            if (vm.lectureId != x.lecture_id){
              return;
            }
            const res = await userService.getUserNameByUserId({
              userId : x.user_id,
            });
            const res2 = await lectureService.getCurrentStudentCount({
              roomId : x.room_id,
            })
            x.creater = res.data.userInfo.name;
            x.current = res2.data.count;
          
            vm.inputlist.push(x);
          });
          
          vm.$notify({
            title: vm.$t('NOTIFY.DELETED'),
            message: vm.$t('NOTIFY.DELETE_SUCCESS'),
            type: 'success',
            duration: 3000,
          });
        } catch (error) {
          vm.$notify({
            title: vm.$t('NOTIFY.DELETE_FAIL'),
            message: error.toString(),
            type: 'error',
            duration: 3000,
          });
        }
        })
        .catch(() => {
          vm.$notify({
            title: vm.$t('NOTIFY.CANCELLED'),
            message: vm.$t('NOTIFY.DELETE_CANCEL'),
            type: 'info',
            duration: 3000,
          });
        });
      }
      //학생은 자신이 만든 방만 지울 수 있음 -> creater id랑 자기 id 확인
      else{
        var targetUser = 0;
        const Info = await lectureService.newgetSmallMeetingRoomList({
          classId : vm.classId,
        });
        Info.data.forEach(x => {
          // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
          if (vm.lectureId != x.lecture_id){
            return;
          }
          if(x.room_id === targetId){
            targetUser = x.user_id;
          }
        });
        if((targetUser != 0)&&(targetUser === vm.myId)){
          vm.$confirm(vm.$t('CONFIRM.WANT_DELETE_ROOM'), vm.$t('CONFIRM.DELETE'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
        .then(async () => {
          try {
            await lectureService.deleteSmallMeetingRoom({ roomId: targetId });
            const roomInfo = await lectureService.newgetSmallMeetingRoomList({
              classId : vm.classId,
            });
            vm.inputlist = [],
            roomInfo.data.forEach(async (x) => {
              // 현재 vm의 lecture_id와 불러온 roomInfo의 lecture_id가 일치하지 않을 경우 표시하지 않는다.
              if (vm.lectureId != x.lecture_id){
                return;
              }
              const res = await userService.getUserNameByUserId({
                userId : x.user_id,
              });
              const res2 = await lectureService.getCurrentStudentCount({
                roomId : x.room_id,
              });
              x.creater = res.data.userInfo.name;
              x.current = res2.data.count;
              
              vm.inputlist.push(x);
            });

            vm.$notify({
              title: vm.$t('NOTIFY.DELETED'),
              message: vm.$t('NOTIFY.DELETE_SUCCESS'),
              type: 'success',
              duration: 3000,
            });
          } catch (error) {
            vm.$notify({
              title: vm.$t('NOTIFY.DELETE_FAIL'),
              message: error.toString(),
              type: 'error',
              duration: 3000,
            });
          }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.CANCELLED'),
              message: vm.$t('NOTIFY.DELETE_CANCEL'),
              type: 'info',
              duration: 3000,
            });
          });
        }
        //ID 다른 경우
        else{
          vm.$notify({
            title: vm.$t('NOTIFY.DELETE_FAIL'),
            message: vm.$t('NOTIFY.SGROUP_DELETE_FAIL'),
            type: 'error',
            duration: 3000,
          });
        }
      }
    },
  },
};
</script>
